# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.starfish_metrics import StarfishMetrics  # noqa: F401,E501
from swagger_server import util


class StarfishEditableParameters(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, api_root: str=None, interval: str=None, metrics: List[StarfishMetrics]=None, topic_name: str=None):  # noqa: E501
        """StarfishEditableParameters - a model defined in Swagger

        :param api_root: The api_root of this StarfishEditableParameters.  # noqa: E501
        :type api_root: str
        :param interval: The interval of this StarfishEditableParameters.  # noqa: E501
        :type interval: str
        :param metrics: The metrics of this StarfishEditableParameters.  # noqa: E501
        :type metrics: List[StarfishMetrics]
        :param topic_name: The topic_name of this StarfishEditableParameters.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'api_root': str,
            'interval': str,
            'metrics': List[StarfishMetrics],
            'topic_name': str
        }

        self.attribute_map = {
            'api_root': 'api-root',
            'interval': 'interval',
            'metrics': 'metrics',
            'topic_name': 'topic-name'
        }
        self._api_root = api_root
        self._interval = interval
        self._metrics = metrics
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'StarfishEditableParameters':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The starfish-editable-parameters of this StarfishEditableParameters.  # noqa: E501
        :rtype: StarfishEditableParameters
        """
        return util.deserialize_model(dikt, cls)

    @property
    def api_root(self) -> str:
        """Gets the api_root of this StarfishEditableParameters.

        Ip address of the api-root to which the HTTP requests must be issued.  # noqa: E501

        :return: The api_root of this StarfishEditableParameters.
        :rtype: str
        """
        return self._api_root

    @api_root.setter
    def api_root(self, api_root: str):
        """Sets the api_root of this StarfishEditableParameters.

        Ip address of the api-root to which the HTTP requests must be issued.  # noqa: E501

        :param api_root: The api_root of this StarfishEditableParameters.
        :type api_root: str
        """

        self._api_root = api_root

    @property
    def interval(self) -> str:
        """Gets the interval of this StarfishEditableParameters.

        The inter-request interval of the Starfish datasource.  # noqa: E501

        :return: The interval of this StarfishEditableParameters.
        :rtype: str
        """
        return self._interval

    @interval.setter
    def interval(self, interval: str):
        """Sets the interval of this StarfishEditableParameters.

        The inter-request interval of the Starfish datasource.  # noqa: E501

        :param interval: The interval of this StarfishEditableParameters.
        :type interval: str
        """

        self._interval = interval

    @property
    def metrics(self) -> List[StarfishMetrics]:
        """Gets the metrics of this StarfishEditableParameters.

        List of the metrics to be retrieved by this datasource.  # noqa: E501

        :return: The metrics of this StarfishEditableParameters.
        :rtype: List[StarfishMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[StarfishMetrics]):
        """Sets the metrics of this StarfishEditableParameters.

        List of the metrics to be retrieved by this datasource.  # noqa: E501

        :param metrics: The metrics of this StarfishEditableParameters.
        :type metrics: List[StarfishMetrics]
        """

        self._metrics = metrics

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this StarfishEditableParameters.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :return: The topic_name of this StarfishEditableParameters.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this StarfishEditableParameters.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :param topic_name: The topic_name of this StarfishEditableParameters.
        :type topic_name: str
        """

        self._topic_name = topic_name
